-- MySQL Script generated by MySQL Workbench
-- Sat Oct 30 19:39:56 2021
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET utf8 ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`Customer`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Customer` (
  `Customer_ID` INT NOT NULL,
  `First_name` VARCHAR(45) NOT NULL,
  `Last_name` VARCHAR(45) NOT NULL,
  `Middle_name` VARCHAR(45) NULL,
  `phone_number` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`Customer_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`address`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`address` (
  `address_ID` INT NOT NULL,
  `city` VARCHAR(45) NOT NULL,
  `street` VARCHAR(45) NOT NULL,
  `house_number` VARCHAR(45) NOT NULL,
  `zip_code` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`address_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Customer_has_address`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Customer_has_address` (
  `Customer_ID` INT NOT NULL,
  `address_type` VARCHAR(45) NOT NULL,
  `expiration_date` DATE NOT NULL,
  `address_address_ID` INT NOT NULL,
  PRIMARY KEY (`Customer_ID`, `address_address_ID`),
  INDEX `fk_Customer_has_address_address1_idx` (`address_address_ID` ASC) VISIBLE,
  CONSTRAINT `fk_Customer_has_address_Customer`
    FOREIGN KEY (`Customer_ID`)
    REFERENCES `mydb`.`Customer` (`Customer_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Customer_has_address_address1`
    FOREIGN KEY (`address_address_ID`)
    REFERENCES `mydb`.`address` (`address_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Saler`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Saler` (
  `Saler_ID` INT NOT NULL,
  `Saler_name` VARCHAR(45) NOT NULL,
  `Saler_surname` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`Saler_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Car`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Car` (
  `Car_ID` INT NOT NULL,
  `VIN_code` INT NOT NULL,
  PRIMARY KEY (`Car_ID`),
  UNIQUE INDEX `VIN_UNIQUE` (`VIN_code` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Sale_invoice`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Sale_invoice` (
  `Invoice_ID` INT NOT NULL,
  `Date` DATE NOT NULL,
  `Saler_ID` INT NOT NULL,
  `Invoice_number` INT NOT NULL,
  `Customer_ID` INT NOT NULL,
  `Car_ID` INT NOT NULL,
  PRIMARY KEY (`Invoice_ID`),
  INDEX `fk_Sale_invoice_Saler1_idx` (`Saler_ID` ASC) VISIBLE,
  UNIQUE INDEX `Invoice_number_UNIQUE` (`Invoice_number` ASC) VISIBLE,
  INDEX `fk_Sale_invoice_Customer1_idx` (`Customer_ID` ASC) VISIBLE,
  INDEX `fk_Sale_invoice_Car1_idx` (`Car_ID` ASC) VISIBLE,
  CONSTRAINT `fk_Sale_invoice_Saler1`
    FOREIGN KEY (`Saler_ID`)
    REFERENCES `mydb`.`Saler` (`Saler_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Sale_invoice_Customer1`
    FOREIGN KEY (`Customer_ID`)
    REFERENCES `mydb`.`Customer` (`Customer_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Sale_invoice_Car1`
    FOREIGN KEY (`Car_ID`)
    REFERENCES `mydb`.`Car` (`Car_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Car_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Car_info` (
  `Car_ID` INT NOT NULL,
  `Year` INT NOT NULL,
  `Producer` VARCHAR(45) NOT NULL,
  `Type` VARCHAR(45) NOT NULL,
  `Color` VARCHAR(45) NOT NULL,
  `Condition` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`Car_ID`),
  CONSTRAINT `fk_Car_info_Car1`
    FOREIGN KEY (`Car_ID`)
    REFERENCES `mydb`.`Car` (`Car_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Parts`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Parts` (
  `Parts_ID` INT NOT NULL,
  `Part_Number` INT NOT NULL,
  `Price_purchres` INT NOT NULL,
  `Price_retail` INT NOT NULL,
  `Information` VARCHAR(45) NULL,
  PRIMARY KEY (`Parts_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Parts_used`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Parts_used` (
  `Parts_used_ID` INT NOT NULL,
  `Parts_ID` INT NOT NULL,
  PRIMARY KEY (`Parts_used_ID`, `Parts_ID`),
  INDEX `fk_Parts_used_Parts1_idx` (`Parts_ID` ASC) VISIBLE,
  CONSTRAINT `fk_Parts_used_Parts1`
    FOREIGN KEY (`Parts_ID`)
    REFERENCES `mydb`.`Parts` (`Parts_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Service`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Service` (
  `Service_ID` INT NOT NULL,
  `Service_name` VARCHAR(45) NOT NULL,
  `Service_Address` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`Service_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Mecanics`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Mecanics` (
  `Mechanic_ID` INT NOT NULL,
  `First_name` VARCHAR(45) NOT NULL,
  `Second_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`Mechanic_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`intermediary_service`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`intermediary_service` (
  `intermediary_service_ID` INT NOT NULL,
  `Service_Service_ID` INT NOT NULL,
  `Mecanics_Mechanic_ID` INT NOT NULL,
  `Hours` INT NOT NULL,
  `Coment` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`intermediary_service_ID`, `Service_Service_ID`, `Mecanics_Mechanic_ID`),
  INDEX `fk_intermediary_service_Service1_idx` (`Service_Service_ID` ASC) VISIBLE,
  INDEX `fk_intermediary_service_Mecanics1_idx` (`Mecanics_Mechanic_ID` ASC) VISIBLE,
  CONSTRAINT `fk_intermediary_service_Service1`
    FOREIGN KEY (`Service_Service_ID`)
    REFERENCES `mydb`.`Service` (`Service_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_intermediary_service_Mecanics1`
    FOREIGN KEY (`Mecanics_Mechanic_ID`)
    REFERENCES `mydb`.`Mecanics` (`Mechanic_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Service_invoice`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Service_invoice` (
  `Car_ID` INT NOT NULL,
  `Customer_ID` INT NOT NULL,
  `Service_invoice_ID` INT NOT NULL,
  `Date_Received` DATE NOT NULL,
  `Date_Return` DATE NOT NULL,
  `Total_Price` INT NOT NULL,
  `Parts_used_ID` INT NOT NULL,
  `intermediary_service_ID` INT NOT NULL,
  PRIMARY KEY (`Car_ID`, `Customer_ID`, `Service_invoice_ID`, `Parts_used_ID`, `intermediary_service_ID`),
  INDEX `fk_Service_invoice_Customer1_idx` (`Customer_ID` ASC) VISIBLE,
  INDEX `fk_Service_invoice_Parts_used1_idx` (`Parts_used_ID` ASC) VISIBLE,
  INDEX `fk_Service_invoice_intermediary_service1_idx` (`intermediary_service_ID` ASC) VISIBLE,
  CONSTRAINT `fk_Service_invoice_Car1`
    FOREIGN KEY (`Car_ID`)
    REFERENCES `mydb`.`Car` (`Car_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Service_invoice_Customer1`
    FOREIGN KEY (`Customer_ID`)
    REFERENCES `mydb`.`Customer` (`Customer_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Service_invoice_Parts_used1`
    FOREIGN KEY (`Parts_used_ID`)
    REFERENCES `mydb`.`Parts_used` (`Parts_used_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Service_invoice_intermediary_service1`
    FOREIGN KEY (`intermediary_service_ID`)
    REFERENCES `mydb`.`intermediary_service` (`intermediary_service_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Mechanics_role`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Mechanics_role` (
  `role_ID` INT NOT NULL,
  `role` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`role_ID`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Mechanics_has_role`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Mechanics_has_role` (
  `Mechanics_role_role_ID` INT NOT NULL,
  `Mecanics_Mechanic_ID` INT NOT NULL,
  `expiration_date` DATE NOT NULL,
  PRIMARY KEY (`Mechanics_role_role_ID`, `Mecanics_Mechanic_ID`),
  INDEX `fk_Mechanics_has_role_Mecanics1_idx` (`Mecanics_Mechanic_ID` ASC) VISIBLE,
  CONSTRAINT `fk_Mechanics_has_role_Mechanics_role1`
    FOREIGN KEY (`Mechanics_role_role_ID`)
    REFERENCES `mydb`.`Mechanics_role` (`role_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Mechanics_has_role_Mecanics1`
    FOREIGN KEY (`Mecanics_Mechanic_ID`)
    REFERENCES `mydb`.`Mecanics` (`Mechanic_ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
